<template>
  <div id="book" class="d-flex justify-content-center">
    <div>

      <BookReader
        v-if="bookReady"
        @update:progress="updateProgress"
        :ebook="book"
        bookArea="bookText"
        :font-size="size"
        :themes="themes"
        :theme="currentTheme"
        :progress.sync="readingProgress"
        @toc="getContent"
        :contentBookModify="0"
      >
      <div id="bookText" slot="book-content" :showContent="showContent" class="mt-5"></div>
        <template slot="progress-bar" slot-scope="props">
          <form class="form-inline">
            <input
              size="3"
              type="range"
              class="slider d-inline"
              max="100"
              min="0"
              step="1"
              @change="props.onChange($event.target.value)"
              :value="readingProgress"
            >
            <input
              size="2"
              type="text"
              class="form-control d-inline mt-2"
              @change="props.onChange($event.target.value)"
              @mousedown="props.onMousedown"
              @mouseup="props.onMouseup"
              :value="readingProgress"
            >%
          </form>
        </template>
      </BookReader>
    </div>
  </div>
</template>


<script>
import EventBus from "../../main";
import vueSlider from "vue-slider-component";
import BookReader from "./BookReader";
import { PreferencesDropdown, TreeMenu } from "vue-epub-reader";
export default {
  name: "BookRender",
  components: {
    BookReader,
    PreferencesDropdown,
    TreeMenu,
    vueSlider
  },
  created(){
      this.$socket.on('resBook',(data)=>{
      this.book = data.book;
      if(data.progress)this.readingProgress=data.progress
      this.bookReady=true
      });
  },
  data() {
    return {
      book:null,
      bookReady:false,
      size: 0,
      currentTheme: "white",
      themes: {
        white: {
          body: {
            color: "#000000",
            background: "#ffffff"
          },
          name: "White"
        },
        beige: {
          body: {
            color: "#000000",
            background: "#f3e8d2"
          },
          name: "Beige"
        },
        night: {
          body: {
            color: "#ffffff",
            background: "#4a4a4a"
          },
          name: "Night"
        }
      },
      serchQuery: "",
      readingProgress: 0,
      openSearch: false,
      openContent: false,
      searchContent: [],
      toc: []
    };
  },
  methods: {
    updateProgress: function(progress) {
      if (this.book.progress != progress) {
        this.book.progress = progress;
        this.$emit('updateProgress',progress)
      }
    },
    toggleSearchWidget() {
      this.openSearch = !this.openSearch;
    },

    showContent() {
      this.openContent = !this.openContent;
    },

    onSearchResults(value) {
      this.searchContent = value;
    },

    getContent(value) {
      this.toc = value;
    },
    showBook() {}
  },
  mounted() {
    this.$root.$on("toc", toc => {
    this.toc = toc;
    });
  }
};
</script>
<style >

.slider {
  -webkit-appearance: none;
  width: 70%;
  margin: 5%;
  height: 25px;
  background: #d3d3d3;
  outline: none;
  opacity: 0.7;
  -webkit-transition: 0.2s;
  transition: opacity 0.2s;
}

.slider:hover {
  opacity: 1;
}

.slider::-webkit-slider-thumb {
  -webkit-appearance: none;
  -moz-appearance: none;
  width: 25px;
  height: 25px;
  background: rgb(5, 5, 110);
  cursor: pointer;
}

.slider::-moz-range-thumb {
  width: 25px;
  height: 25px;
  background: rgb(5, 5, 110);
  cursor: pointer;
}
</style>
